/*
SRTableView.m

Author: Makoto Kinoshita

Copyright 2004 The Shiira Project. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted 
provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions 
  and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of 
  conditions and the following disclaimer in the documentation and/or other materials provided 
  with the distribution.

THIS SOFTWARE IS PROVIDED BY THE SHIIRA PROJECT ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE SHIIRA PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE.
*/

#import "SRTableView.h"

@implementation SRTableView

- (void)keyDown:(NSEvent*)event
{
    // For delete key
    if ([[event charactersIgnoringModifiers] characterAtIndex:0] == NSDeleteCharacter) {
        // Ignore it
        return;
    }
    
    [super keyDown:event];
}

- (void)keyUp:(NSEvent*)event
{
    // For delete key
    if ([[event charactersIgnoringModifiers] characterAtIndex:0] == NSDeleteCharacter) {
        // Notify it delegate
        id  delegate;
        delegate = [self delegate];
        if ([delegate respondsToSelector:@selector(tableViewDeleteSelectedItem:)]) {
            [delegate tableViewDeleteSelectedItem:self];
        }
        
        return;
    }
    
    [super keyUp:event];
}

- (void)mouseDown:(NSEvent*)event
{
    // Show context menu by mouse press holding
    if (SRShowContextMenuByMousePressHolding(self, event)) {
        return;
    }
    
    [super mouseDown:event];
}

- (unsigned int)draggingSourceOperationMaskForLocal:(BOOL)isLocal
{
    return NSDragOperationGeneric;
}

@end
